// ============================================================================
// ==                                                                        ==
// == AMDiS - Adaptive multidimensional simulations                          ==
// ==                                                                        ==
// ============================================================================
// ==                                                                        ==
// ==  crystal growth group                                                  ==
// ==                                                                        ==
// ==  Stiftung caesar                                                       ==
// ==  Ludwig-Erhard-Allee 2                                                 ==
// ==  53175 Bonn                                                            ==
// ==  germany                                                               ==
// ==                                                                        ==
// ============================================================================
// ==                                                                        ==
// ==  http://www.caesar.de/cg/AMDiS                                         ==
// ==                                                                        ==
// ============================================================================

/** \file V3Vector.h */

#ifndef AMDIS_V3VECTOR_H
#define AMDIS_V3VECTOR_H

#include <vector>
#include "Global.h"
#include "MemoryManager.h"
#include "CreatorInterface.h"

namespace AMDiS {

  class M33 {
  public:
    M33();

    ~M33();

    void set(int row, int col, double value);

    bool operator==(const M33 &a) const {
      return data == a.getData();
    };

    bool operator!=(const M33 &a) const {
      return data != a.getData();
    };

    ::std::vector<double> getData() const {
      return data;
    };

    inline double operator[](int i) const {
      return(data[i]);
    }

    void print();

  private:
    ::std::vector<double> data;
  };

   struct MatEntry33
  {
    DegreeOfFreedom col;
    
    M33 entry;    
  };
/*
  typedef ::std::vector<double>  V3;

  class V3Creator : public CreatorInterface< ::std::vector<V3> > {
  public:
    MEMORY_MANAGED(V3Creator);

    V3Creator(int size)
      : size_(size)
    {};

    virtual ~V3Creator() {};

    ::std::vector<V3> *create() {
      ::std::vector<V3> *vec = new ::std::vector<V3>(size_, V3(3));

      return vec;
    };

    void free(::std::vector<V3> *vec) { 
      delete vec;
    };    

  private:
    int size_;
  };

  double norm(::std::vector<V3> *v);

  void setValue(::std::vector<V3>& v, double value);

  const V3& operator += (V3& x1, const V3 x2);

  const ::std::vector<V3>& operator*=(::std::vector<V3>& x, double scal);

  const ::std::vector<V3>& operator+=(::std::vector<V3>& x1,
  				      const ::std::vector<V3>& x2);
 
  double operator*(::std::vector<V3>& x1, ::std::vector<V3>& x2);

  void axpy(double alpha, const ::std::vector<V3>& x, ::std::vector<V3>& y);

  void xpay(double alpha, const ::std::vector<V3>& x, ::std::vector<V3>& y);

  V3 mult(M33 mat, V3 vec);

  void print(::std::vector<V3> *v);*/
}

#endif
